//+-------------------------------------------------------------------------+
//|                                                     PA candlestick.mq4  |
//+-------------------------------------------------------------------------+
#property copyright "brax64"
#property link      "http://www.forex-tsd.com"

#property indicator_chart_window

extern color Up_power_color = Lime;
extern color Dn_power_color = Red;
extern color Bkgrnd_Color   = DimGray;
extern int   Pan_X          = 10;
extern int   Pan_Y          = 10;

double Up[], Dn[];
string ID = "B_B Power ";

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
{
   IndicatorBuffers(2); 
   IndicatorShortName("PA candlestick");
   SetIndexBuffer(0,Up); SetIndexStyle(0,DRAW_NONE);
   SetIndexBuffer(1,Dn); SetIndexStyle(1,DRAW_NONE);
    
   return(0);
}

int deinit()
{
   string lookFor       = ID;
   int    lookForLength = StringLen(lookFor);   
   for(int i = ObjectsTotal() - 1; i >= 0; i--)
   {
      string name = ObjectName(i);
         if(StringSubstr(name, 0, lookForLength) == lookFor) ObjectDelete(name);
   }
   return(0);
}

//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
{
   int Candles = 4;
   int dig = MarketInfo(Symbol(), MODE_DIGITS);
   int modifier = 1;
   if(dig == 3 || dig == 5) modifier = 10;
   double factor = Point * modifier;
   
   for(int i = 0; i <= Candles; i++)
   {
      if(Close[i] >= Open[i]) {Up[i] = (High[i] - Close[i]); Dn[i] = (Open[i]  - Low[i]);}
      if(Close[i] <  Open[i]) {Up[i] = (High[i] - Open[i]);  Dn[i] = (Close[i] - Low[i]);}
   }     
      
   double upsum = (Up[0] + Up[1] + Up[2] + Up[3] + Up[4]) / factor;
   double dnsum = (Dn[0] + Dn[1] + Dn[2] + Dn[3] + Dn[4]) / factor;
   double bullpower = NormalizeDouble((dnsum/upsum),2);
   double bearpower = NormalizeDouble((upsum/dnsum),2);

   ObjectCreate (ID + "_00", OBJ_LABEL, 0, 0, 0);
   ObjectSetText(ID + "_00", "gg", 40, "Webdings");
       ObjectSet(ID + "_00", OBJPROP_CORNER, 0);
       ObjectSet(ID + "_00", OBJPROP_XDISTANCE, Pan_X);
       ObjectSet(ID + "_00", OBJPROP_YDISTANCE, Pan_Y);      
       ObjectSet(ID + "_00", OBJPROP_COLOR, Bkgrnd_Color);
       ObjectSet(ID + "_00", OBJPROP_BACK, false);
   
   ObjectCreate (ID + "Bull0", OBJ_LABEL, 0, 0, 0);
   ObjectSetText(ID + "Bull0", CharToStr(233), 18, "Wingdings", Up_power_color);
       ObjectSet(ID + "Bull0", OBJPROP_CORNER, 0);
       ObjectSet(ID + "Bull0", OBJPROP_XDISTANCE, 5 + Pan_X);
       ObjectSet(ID + "Bull0", OBJPROP_YDISTANCE, 0 + Pan_Y);
       ObjectSet(ID + "Bull0", OBJPROP_BACK, false);
   
   ObjectCreate (ID + "Bull1", OBJ_LABEL, 0, 0, 0);
   ObjectSetText(ID + "Bull1", DoubleToStr(bullpower,2), 16, "Verdana Bold", Up_power_color);
       ObjectSet(ID + "Bull1", OBJPROP_CORNER, 0);
       ObjectSet(ID + "Bull1", OBJPROP_XDISTANCE, 40 + Pan_X);
       ObjectSet(ID + "Bull1", OBJPROP_YDISTANCE, 2 + Pan_Y);
       ObjectSet(ID + "Bull1", OBJPROP_BACK, false);
   
   ObjectCreate (ID + "Bear0", OBJ_LABEL, 0, 0, 0);
   ObjectSetText(ID + "Bear0", CharToStr(234), 18, "Wingdings", Dn_power_color);
       ObjectSet(ID + "Bear0", OBJPROP_CORNER, 0);
       ObjectSet(ID + "Bear0", OBJPROP_XDISTANCE, 5 + Pan_X);
       ObjectSet(ID + "Bear0", OBJPROP_YDISTANCE, 30 + Pan_Y);
       ObjectSet(ID + "Bear0", OBJPROP_BACK, false);
   
   ObjectCreate (ID + "Bear1", OBJ_LABEL, 0, 0, 0);
   ObjectSetText(ID + "Bear1", DoubleToStr(bearpower,2), 16, "Verdana Bold", Dn_power_color);
       ObjectSet(ID + "Bear1", OBJPROP_CORNER, 0);
       ObjectSet(ID + "Bear1", OBJPROP_XDISTANCE, 40 + Pan_X);
       ObjectSet(ID + "Bear1", OBJPROP_YDISTANCE, 28 + Pan_Y);
       ObjectSet(ID + "Bear1", OBJPROP_BACK, false);
   
   return(0);
}